package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired EmployeeRepository employeeRepository;


  public List<Employee> findAllEmployees() {
    /*some business*/
    return employeeRepository.findAll();
  }


  public Employee addEmployee(Employee employee) {
    //save persists the info on the jpa database
    return employeeRepository.save(employee);
  }


  public Optional<Employee> getEmployeeById(Long employeeId) {
    return employeeRepository.findById(employeeId);
  }



  //without error message
//  public Employee editEmployee(Optional<Employee> employee, Employee employeeDetails) {
//    Employee employeeObj = employee.get();
//    employeeObj.setFirstName(employeeDetails.getFirstName());
//    employeeObj.setLastName(employeeDetails.getLastName());
//    return employeeRepository.save(employeeObj);
//  }


  public Employee editEmployee(Employee employee, Employee employeeDetails) {
    employee.setFirstName(employeeDetails.getFirstName());
    employee.setLastName(employeeDetails.getLastName());
    return employeeRepository.save(employee);
  }

  public void delete(Employee employee) {
    employeeRepository.delete(employee);
  }


}
